# this is a comment by ezra
# this is a comment by richard

#(please follow this so know what i wrote)

# ++++++++++++++++++++++++++++++++++++++++++++++++++ #
# ===================   import   =================== #
# ++++++++++++++++++++++++++++++++++++++++++++++++++ #

import pygame
import math
import os
import sys
from pygame.locals import *

from OpenGL.GL import *
from OpenGL.GLU import *
from PyOpenGLtoolbox import *

# pygame.init()

# pygame.mixer.music.load("Collapse.mp3")
# pygame.mixer.music.play(loops=0, start=120567)

# ++++++++++++++++++++++++++++++++++++++++++++++++++ #
# ===================   define   =================== #
# ++++++++++++++++++++++++++++++++++++++++++++++++++ #

rows = 5 # 4
start_multiplier = 0.85 # 0.85
row_multipliers = []
for a_row in range(0, rows):
    row_multipliers.append(abs(1 - rows/2 - a_row)*0.1)  # 0.1


cube_verticies = [
    [1, -1, -1],
    [1, 1, -1],
    [-1, 1, -1],
    [-1, -1, -1],
    [1, -1, 1],
    [1, 1, 1],
    [-1, -1, 1],
    [-1, 1, 1]
    ]

cube_edges = [
    [0,1],
    [0,3],
    [0,4],
    [2,1],
    [2,3],
    [2,7],
    [6,3],
    [6,4],
    [6,7],
    [5,1],
    [5,4],
    [5,7]
    ]

grid_verticies = (
    #Border verts:
    (-1, -1, 0),
    (-1, 1, 0),
    (1, 1, 0),
    (1, -1, 0),

    #Middle verts:
    (-1, 0, 0),
    (0, 1, 0),
    (1, 0, 0),
    (0, -1, 0)
    )

grid_edges = (
    #Border edges:
    (0,1),
    (1,2),
    (2,3),
    (3,0),

    #Middle edges:
    (4,6),
    (5,7)
    )

pgrid_verticies = []
pgrid_edges = []

#don't read this comment

# +++++++++++++++++++++++++++++++++++++++++++++++++ #
# =================== functions =================== #
# +++++++++++++++++++++++++++++++++++++++++++++++++ #

def pgrid_data():
    global pgrid_verticies, pgrid_edges, rows
    verticies_list = []
    edges_list = []
    gen_rows = rows  # for now only odd numbers.

    #actually good code by richard, all i know is that it divdes stuff and turns it into data based on rows :)
    for i, a_point in enumerate(range(0, rows*rows)):
        the_row = int(i / rows)
        the_col = int(i % rows) 
        center_x = (rows-1)/2
        center_y = (rows-1)/2

        verticies_list.append([the_col - center_x, the_row - center_y, 0])

        if the_col != 0:
            edges_list.append([i-1, i])
        if the_row != 0:
            edges_list.append([i-rows, i])

    #self-explanitory, just read the code dumbass :V

    pgrid_verticies = list(verticies_list)
    pgrid_edges = list(edges_list)
    return pgrid_verticies, pgrid_edges


def print_vertices():
    global pgrid_verticies, rows
    print_string = "|"
    for i, a_point in enumerate(pgrid_verticies):
        print_string += " " + str(a_point) + " |"
        if i % rows == rows - 1:
            print_string += "\n"
    print(print_string)
        

def squish_point(a_point, multiplier=2):

    # Multiply x axis by multiplier, we're only stretching horizontally.
    the_squish = [round(a*b, 2) for a,b in zip(a_point, [multiplier, 1, 1])]
    return the_squish

def length_row(pgrid_verticies, the_row):
    global rows
    row_length = 0
    first_in_row = pgrid_verticies[rows*the_row]
    last_in_row = pgrid_verticies[rows*the_row+rows-1]

    row_length = abs(last_in_row[0] - first_in_row[0])

    return row_length

def squish_loop():
    global pgrid_verticies, pgrid_edges, rows, row_multipliers

    #define multiplier and limit vars

    # multiplier = 1.05 
    # outer_limit_total = 0    # count number of limits in a row, if too many, switch multiplier
    # inner_limit_total = 0

    #print row stuff


    for i, a_point in enumerate(pgrid_verticies):
        the_row = int(i / rows)
        the_col = int(i % rows) 
        if i == 0:
            print_vertices()
        if the_col == 0:
            row_length = length_row(pgrid_verticies, the_row)
            print("Row Length: ", row_length)
            # Hit walls for first time.
            if row_length >= 10: 
                row_multipliers[the_row] = 0.952380952
                # multiplier = 1 / multiplier # flip our multiplier to begin shrinking / growing.
                print ("============= Outer Wall " + str(the_row) + ", " + str(the_col) + " =============")
                print("|Outer Multiplier Flip:\t", end="")
                print(row_multipliers[the_row], "|")
                print()
                # outer_limit_total = 0
                
            elif row_length <= 0.5:
                
                # multiplier = 1 / multiplier # flip our multiplier to begin shrinking / growing.
                row_multipliers[the_row] = 1.05
                print ("------------ Inner Wall " + str(the_row) + ", " + str(the_col) + " --------------")
                print("|Inner Multiplier Flip:\t", end="")
                print(row_multipliers[the_row], "|")
                print()
                # inner_limit_total = 0

        pgrid_verticies[i] = squish_point(a_point, row_multipliers[the_row])

def pgrid():
    global pgrid_verticies, pgrid_edges
    glBegin(GL_LINES)
    for edge in pgrid_edges:
        for vertex in edge:
            glVertex3fv(pgrid_verticies[vertex])
    glEnd()


def Cube():
    glBegin(GL_LINES)
    for edge in cube_edges:
        for vertex in edge:
            glVertex3fv(cube_verticies[vertex])
    glEnd()

def grid():
    glBegin(GL_LINES)
    for edge in grid_edges:
        for vertex in edge:
            glVertex3fv(grid_verticies[vertex])
    glEnd()


def main():
    global pgrid_verticies
    i = 0
    counter = 0

    # +++++++++++++++++++++++++++++++++++++++++++++++++++ #
    # =================== pygame init =================== #
    # +++++++++++++++++++++++++++++++++++++++++++++++++++ #

    pgv1, pge1 = pgrid_data()
    pygame.init()
    display = (800,600)
    pygame.display.set_caption("MopeDude's @party 10th Anniversary Demo!")
    pygame.display.set_mode(display, DOUBLEBUF|OPENGL)

    gluPerspective(100, (display[0]/display[1]), 0.1, 50.0)
    gluLookAt(0, 0, -10, 0, 0, 0, 0, 1, 0)
    glTranslatef(0.0,0.0, -5)
    
    # +++++++++++++++++++++++++++++++++++++++++++++++++++ #
    # =================== pygame loop =================== #
    # +++++++++++++++++++++++++++++++++++++++++++++++++++ #

    while True:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                quit()
        squish_loop()
        i += 1
        counter += 1
        # if counter % 2:
        #     grid_x = pgrid_verticies[0][0] - 1
        # else:
        #     grid_x = pgrid_verticies[0][0] + 1
        # pgrid_list = list(pgrid_verticies)
        # pgrid_list[0] = ( grid_x, grid_x, 0)
        # pgrid_verticies = list(pgrid_list)
        # print()
        # print("Counter: " + str(counter))
        # print(pgrid_verticies[0])
        # if i < 180:
        glRotatef(1, 2, 0, 0)
        #     i += 1
        # else:
        #     pgrid_verticies[0][0] - 1
        #     i = 0
        #     # pygame.time.wait(400)
        glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT)

        pgrid()
        #grid()
        #Cube()
        pygame.display.flip()
        pygame.time.wait(10)

# +++++++++++++++++++++++++++++++++++++++++++++++++ #
# ===================    run    =================== #
# +++++++++++++++++++++++++++++++++++++++++++++++++ #

if __name__ == "__main__":
    main()

# +++++++++++++++++++++++++++++++++++++++++++++++++ #
# ===================    end    =================== #
# +++++++++++++++++++++++++++++++++++++++++++++++++ #